
class Letter{
public:
  vcg::Point2f pos; // position
  vcg::Point2f ori; // orientation
  
  char c; // the letter
  
  float size;
  bool italic;
  int width;
  int alpha; 
  float angle;
  Letter *original; // if it is a duplicate, this is not null
  
  void SaveIntoBRF(FILE* f);
  void SaveIntoParties(FILE* f, int pos);
  void SaveIntoMapIcons(FILE* f, int pos);
  char* MeshIde();
  void Render();
  
  bool IsSimilarTo(const Letter &l);
  void SetSimilarTo(Letter &l);
  
  Letter();
  Letter(char _c);

  int index;
  unsigned int mbindex; // index used inside M&B
  
  static void ResetAll();

  // find a map vertex where to sit
  void SitOnVertex();
  void SetMeshPos();

private:
  vcg::Point2f DX() const;
  vcg::Point2f DY(int zeroone) const;
  
  float meshZ[4];
  vcg::Point2f meshXY[4];
  
  vcg::Point2f anchorPos; // where to "anchor" the icon
};
