#include <GL\gl.h>
#include <GL\openglut.h>
#include <stdio.h>

#include "msgGUI.h"


extern int scrW, scrH,curSpline;
int NSplines();

void  SetCoordToPixel(){
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  glTranslatef(-1,-1,0);
  glScalef(2.0/scrW, 2.0/scrH, 1);
}

void outText(int x, int y, float col, const char*c){
  glColor4f(col,col,col,1);
  glRasterPos2d(x,y);
  while (*c) glutBitmapCharacter(GLUT_BITMAP_HELVETICA_12, *c++);
}

bool Msg::helpOn;

const int NMSG=4;

char msg[4][1024]={"","","",""};
int curmsg=0;

void Msg::Add(char *st){
  sprintf(msg[curmsg],"%s",st);
  curmsg=(curmsg+1)%NMSG;
}

void Msg::ShowMiddle(char* text){
  outText(scrW/2-95,scrH/2-5,1,text);
}

void Msg::Render(){
  glDisable(GL_TEXTURE_2D);
  SetCoordToPixel();
  int y=-8, x=5;
  for (int i=0; i<NMSG; i++) {
    int k=(curmsg+NMSG-i-1)%NMSG;
    if (msg[k][0])
    outText(x,y+=15,0.8,msg[k]);
  }

}

void Msg::DumpLog(){
  FILE *f=fopen("log.txt","wt");
  for (int i=0; i<NMSG; i++) {
    int k=(curmsg+NMSG-i-1)%NMSG;
    if (msg[k][0])fprintf(f,"%s\n",msg[k]);
  }
  fclose(f);
}

void Msg::ShowHelp(){
  glDisable(GL_TEXTURE_2D);
  SetCoordToPixel();
  int y=scrH+2, x=5;
  outText(x,y-=15,0.99,helpOn?"HELP (F1 to hide)":"(F1 to show HELP)");
  y-=5;
  if (helpOn) {
    outText(x,y-=15,0.99,"View");
    outText(x,y-=15,0.8," [mouse wheel]: zoom in/out");
    outText(x,y-=15,0.8," [mouse right]: drag map");
    y-=5;
    outText(x,y-=15,0.99,"Basic editing");
    outText(x,y-=15,0.8," [mouse left]: drag on an empty region to create a new label");
    if (NSplines()>0) {
    outText(x,y-=15,0.8," [mouse left]: click on a label to select");
    outText(x,y-=15,0.8," [tab]: select next label");
    if (curSpline>=0) { 
      outText(x,y-=15,0.8," [mouse left]: drag control nodes ");
      outText(x,y-=15,0.8," [just type]: edit label text ");
  
      y-=5;
      outText(x,y-=15,0.99,"Character");
      outText(x,y-=15,0.8," [mouse middle]: drag up/down to change Size");
      outText(x,y-=15,0.8," [shift-mouse middle]: drag up/down to change Width");
      outText(x,y-=15,0.8," [pagUp/pagDown]: change label transparency");
      outText(x,y-=15,0.8," [ctrl-i]: italics on-off");
      outText(x,y-=15,0.8," [ctrl-f]: flip text");
      outText(x,y-=15,0.8," [ctrl-p]: CAPS - Caps - caps");
      outText(x,y-=15,0.8," [ctrl-c]/[ctrl-v]: cut'n'paste text attr");
     }
    }
    y-=5;
    outText(x,y-=15,0.99,"General");
    outText(x,y-=15,0.8," [F2]: save labels (will be loaded on startup)");
    outText(x,y-=15,0.8," [F12]: export map labels into the MOD!");
    outText(x,y-=15,0.8," [Esc]: bye");
    y-=5;
    outText(x,y-=15,0.99,"Utils");
    outText(x,y-=15,0.8," [ctrl-d]: count letters that can use duplicates");
  }

}

void Msg::ShowStats(float size, int alpha, int width, bool italic){
  SetCoordToPixel();
  int y=scrH+2, x=scrW-107;
  static char txt[256];
  sprintf(txt,"         Visib:%s%3d%%", (alpha<100)?" ":"", alpha);
  outText(x,y-=15,0.90,txt);
  sprintf(txt,"          Size:  %3.2f", size);
  outText(x,y-=15,0.90,txt);
  sprintf(txt,"Font Width:  %s%3d%%", (width<100)?" ":"", width);
  if (width!=100) outText(x,y-=15,0.90,txt);
  
  
  //if (italic) outText(x,y-=15,0.90,"Italics");
}
