
class Spline{
public:
  // data in relative coord
  vcg::Point2f v[4];
  
  // data in world
  vcg::Point2f vw[4];
  
  vcg::Point2f Pos(float t);
  vcg::Point2f Ori(float t);
  
  void Render(bool selected, int selNode);
  
  void Set(vcg::Point2f a, vcg::Point2f b);
  void SetNodePos(vcg::Point2f x, int i);
  
  void GetReady();
  
  std::vector<Letter> letter;
  
  void ArrangeLetters();
  void AddLetter(char c);
  bool RemoveLetter();
  void IncrSize(float howmuch);
  void IncrAlpha(int howmuch);
  void IncrWidth(int howmuch);
  void UpdateLetterStats();
  vcg::Point2f Center(); 

  int GetNIcons();// reutrn needed number of icons, i.e. non ' ' letters
  
  float lettersize;
  int alpha;
  bool italic;
  int width;
  int colindex;

  float Dist(vcg::Point2f x); // distance spline-point
  float NodeDist(vcg::Point2f x, int i); // distance splinenode-point
 
  Spline();
  void Flip();
  void Save(FILE *f);
  void Load(FILE *f, int ver);
  char* GetString() const;
  float GetRadius() const;
  
  void CopyStats(const Spline& sp);
  void ChangeAllCaps();
private:
  int tmpwidth;
};
